=== removed file 'dashboard_app/templates/dashboard_app/image_status_detail.html'
--- dashboard_app/templates/dashboard_app/image_status_detail.html	2011-10-11 12:02:02 +0000
+++ dashboard_app/templates/dashboard_app/image_status_detail.html	1970-01-01 00:00:00 +0000
@@ -1,186 +0,0 @@
-{% extends "dashboard_app/_content.html" %}
-{% load call %}
-{% load i18n %}
-
-
-{% block extrahead %}
-{{ block.super }}
-<!--[if IE]><script type="text/javascript" src="{{ STATIC_URL }}dashboard_app/js/excanvas.min.js"></script><![endif]-->
-<script type="text/javascript" src="{{ STATIC_URL }}dashboard_app/js/jquery.flot.min.js"></script>
-<script type="text/javascript" src="{{ STATIC_URL }}dashboard_app/js/jquery.flot.stack.min.js"></script>
-<script type="text/javascript" src="{{ STATIC_URL }}dashboard_app/js/jquery.flot.axislabels.js"></script>
-{% endblock %}
-
-
-{% block content %}
-<h2>Test history for image {{ image_health.rootfs_type }} + {{ image_health.hwpack_type }}</h2>
-{% with image_health.get_recent_test_runs as recent_test_run_list %}
-{% if recent_test_run_list %}
-<div id="legend" style="margin: auto;"></div>
-<div id="placeholder" style="height: 250px; margin: auto;"></div>
-<script type="text/javascript">
-  $(function () {
-    var css_id = "#placeholder";
-
-    {% with image_health.get_chart_data as chart_data %} 
-
-    {% regroup chart_data|dictsort:"bucket" by bucket as bucket_list %}
-    var tick_list = [
-      {% spaceless %}
-      {% for bucket in bucket_list %}
-      "{{ bucket.grouper }}",
-      {% endfor %}
-      {% endspaceless %}
-    ];
-    var tick_label_list = [
-      {% spaceless %}
-      {% for bucket in bucket_list %}
-      [ {{ forloop.counter0 }}, "{{ bucket.grouper }}"],
-      {% endfor %}
-      {% endspaceless %}
-    ];
-
-    {% regroup chart_data|dictsort:"result" by result as series_group_list %}
-    var label_for = ["pass", "fail", "skip", "unknown"];
-    var color_for = ["#3aad3a", "#ff3800", "yellow", "#aaad9c"];
-    var data = [
-      {% for chart_series in series_group_list %}
-      {
-        label: label_for[{{ chart_series.grouper }}],
-        color: color_for[{{ chart_series.grouper }}],
-        data: [
-          {% spaceless %}
-          {% for sample in chart_series.list %}
-          [ tick_list.indexOf("{{ sample.bucket }}"), {{ sample.count }}],
-          {% endfor %}
-          {% endspaceless %}
-        ]
-      },
-      {% endfor %}
-    ];
-    
-    {% endwith %}
-
-    var options = {
-      legend: {
-        container: "#legend",
-        noColumns: 4,
-      },
-      grid: {
-        show: true,
-        aboveData: false,
-        backgroundColor: 'white',
-        color: '#333',
-        borderColor: null
-      },
-      series: {
-        stack: 0,
-        lines: {
-          show: false,
-          fill: false,
-          steps: false
-        },
-        bars: {
-          show: true,
-          fill: true,
-          barWidth: 0.5,
-          align: "center",
-          lineWidth: 0,
-          fillColor: {
-            colors: [
-              { opacity: 1 },
-              { opacity: 1 },
-              { opacity: 1 },
-              { opacity: 1 }
-            ]
-          }
-        },
-      },
-      xaxis: {
-        label: "Day of testing",
-        ticks: tick_label_list,
-      },
-      yaxis: {
-        labelPos: "low",
-        label: "Number of test cases",
-      },
-    };
-
-    $.plot($(css_id), data, options);
-  }); 
-</script>
-<style type="text/css">
-  .result_pass {
-    background-color: #3aad3a;
-  }
-  
-  .result_fail {
-    background-color: #ff3800;
-  }
-  
-  .result_skip {
-    background-color: yellow;
-  }
-  
-  .result_unknown {
-    background-color: #aaad9c;
-  }
-  
-  .helper {
-    float: left;
-    height: 1em;
-    margin-left: 1px;
-  }
-
-  table.special {
-    border-collapse: collapse;
-    width: 100%;
-  }
-
-  table.special th {
-    text-align: left;
-    border-bottom: 1px solid #333;
-    padding: 2pt;
-  }
-</style>
-<table class="special">
-  {% regroup recent_test_run_list by analyzer_assigned_date|date:"Y-m-d" as test_run_cluster_list %}
-  {% for test_run_cluster in test_run_cluster_list %}
-  <tr>
-    <th colspan="2">Tests ran on {{ test_run_cluster.grouper }}</th>
-    <th>Pass</th>
-    <th>Fail</th>
-    <th>Skip</th>
-    <th>Unknown</th>
-  </tr>
-  {% for test_run in test_run_cluster.list %}
-  <tr>
-    <td><a href="{{ test_run.get_absolute_url }}">{{ test_run.test }}</a></td>
-    {% with test_run.denormalization as denormalization %}
-    <td>
-      {% spaceless %}
-      <div class="result_pass helper"
-        style="width: {% widthratio denormalization.count_pass denormalization.count_all 500 %}px;"></div>
-      <div class="result_fail helper"
-        style="width: {% widthratio denormalization.count_fail denormalization.count_all 500 %}px;"></div>
-      <div class="result_skip helper"
-        style="width: {% widthratio denormalization.count_skip denormalization.count_all 500 %}px;"></div>
-      <div class="result_unknown helper"
-        style="width: {% widthratio denormalization.count_unknown denormalization.count_all 500 %}px;"></div>
-      {% endspaceless %}
-    </td>
-    <td>{{ denormalization.count_pass }}</td>
-    <td>{{ denormalization.count_fail }}</td>
-    <td>{{ denormalization.count_skip }}</td>
-    <td>{{ denormalization.count_unknown }}</td>
-    {% endwith %}
-  </tr>
-  {% endfor %}
-  {% endfor %}
-</table>
-{% else %}
-<p>This combination of of root file system + hwardware pack was not tested in
-the last 14 days</p>
-{% endif %}
-{% endwith %}
-{% endblock %}

=== removed file 'dashboard_app/templates/dashboard_app/image_status_list.html'
--- dashboard_app/templates/dashboard_app/image_status_list.html	2011-07-22 00:57:44 +0000
+++ dashboard_app/templates/dashboard_app/image_status_list.html	1970-01-01 00:00:00 +0000
@@ -1,38 +0,0 @@
-{% extends "dashboard_app/_content.html" %}
-{% load call %}
-
-
-{% block content %}
-<script type="text/javascript" charset="utf-8"> 
-  $(document).ready(function() {
-    oTable = $('#LEBs').dataTable({
-      "bJQueryUI": true,
-      "bPaginate": false,
-    });
-  });
-</script> 
-<table class="demo_jui display" id="LEBs">
-  <thead>
-    <tr>
-      <th></th>
-      {% for hwpack in hwpack_list %}
-      <th>{{ hwpack }}</th>
-      {% endfor %}
-    </tr>
-  </thead>
-  <tbody>
-    {% for rootfs in rootfs_list %}
-    <tr>
-      <th>{{ rootfs }}</th>
-      {% for hwpack in hwpack_list %}
-      <td>
-        {% call ImageHealth rootfs hwpack as image_health %}
-        <a href="{{ image_health.get_absolute_url }}">{{ image_health.get_test_runs.count }} test runs</a>
-        {% endcall %}
-      </td>
-      {% endfor %}
-    </tr>
-    {% endfor %}
-  </tbody>
-</table>
-{% endblock %}

=== removed file 'dashboard_app/templates/dashboard_app/image_test_history.html'
--- dashboard_app/templates/dashboard_app/image_test_history.html	2011-07-22 00:57:44 +0000
+++ dashboard_app/templates/dashboard_app/image_test_history.html	1970-01-01 00:00:00 +0000
@@ -1,15 +0,0 @@
-{% extends "dashboard_app/_content.html" %}
-
-
-{% block content %}
-<script type="text/javascript">
-  $(document).ready(function() {
-    $('#test_runs').dataTable({
-      bJQueryUI: true,
-      sPaginationType: "full_numbers",
-      aaSorting: [[0, "desc"]],
-    });
-  });
-</script>
-{% include "dashboard_app/_test_run_list_table.html" %}
-{% endblock %}